unit TestComposTutoMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SelDirDlg, ExtCtrls, DropImg, CircChart, ActnList;

type
  TFormMain = class(TForm)
    ButtonSelectDir: TButton;
    EditDirectory: TEdit;
    SelectDirDialog: TSelectDirDialog;
    DropImage: TDropImage;
    CircleChart: TCircleChart;
    LabelQuestion: TLabel;
    ActionList: TActionList;
    ActionBelgium: TChartQuarterAction;
    ActionOthers: TChartQuarterAction;
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ActionBelgiumExecute(Sender: TObject);
    procedure CircleChartClickQuarter(Sender: TObject; Index: Integer;
      Quarter: TChartQuarter);
    procedure DropImageDrop(Sender: TObject; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ButtonSelectDirClick(Sender: TObject);
    procedure SelectDirDialogAccept(Sender: TObject; Directory : TDirName);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

procedure TFormMain.FormCreate(Sender: TObject);
begin
  EditDirectory.Text := ExtractFilePath(Application.ExeName);
end;

procedure TFormMain.ButtonSelectDirClick(Sender: TObject);
begin
  SelectDirDialog.Directory := EditDirectory.Text;
  SelectDirDialog.Execute;
end;

procedure TFormMain.SelectDirDialogAccept(Sender: TObject; Directory : TDirName);
begin
  EditDirectory.Text := Directory;
end;

procedure TFormMain.DropImageDrop(Sender: TObject; X, Y: Integer);
var Quarter : integer;
begin
  Quarter := CircleChart.PointToQuarterIndex(Point(X, Y));
  if Quarter = 1 then
    ShowMessage('En effet, Dveloppez.com est bien un site franais')
  else if Quarter <> -1 then
    ShowMessage('Non, ce n''est pas a, ressayez');
end;

procedure TFormMain.CircleChartClickQuarter(Sender: TObject; Index: Integer;
  Quarter: TChartQuarter);
begin
  ShowMessage(Format('Vous avez cliqu sur le quartier n%d.'#10'Ce quartier a pour libell "%s" et pour valeur %f.',
    [Index, Quarter.Text, Quarter.Percent]));
end;

procedure TFormMain.ActionBelgiumExecute(Sender: TObject);
begin
  ShowMessage('Vous m''avez l''air d''un gars bien sympatique, puisque vous avez cliqu sur la Belgique !');
end;

procedure TFormMain.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
  if WheelDelta > 0 then WheelDelta := 3 else WheelDelta := -3;
  if PtInRect(CircleChart.BoundsRect, ScreenToClient(MousePos)) then
    CircleChart.BaseAngle := CircleChart.BaseAngle + WheelDelta;
end;

end.
